/*

The NetUsage Project
http://netusage.mozdev.org/

Copyright (C) 2004, NetUsage Project
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
NetUsage ToolItem

*/

var netusageobj = {
	animating: false,
	anipos: 9,
	anistep: 1,
	anitimer: null,

	tooltiphide: false,

	usageprogressbar: null,

	observe: function (subject, topic, data) {
		if (topic == 'timer-callback') {
			this.anitimercallback();
		} else {
			switch (data) {
			case 'draw':
				if (document.getElementById('usagebtn-container'))
				try {
				this.animating = false;
				var hud = document.getElementById('usagebtn-hud');
				hud.setAttribute('style', "");
				var tipinfo = document.getElementById('usagebtn-tip-info');
				tipinfo.setAttribute('style', "display: none");
				var usagedata = Components.classes["@mozilla.org/netusagecom;1"].getService().QueryInterface(Components.interfaces.nsINetUsageData);
				this.drawusage(usagedata);
				} catch(e) { alert(e); }
				break;

			case 'start':
				if (document.getElementById('usagebtn-container'))
				try {
this.animating = true;
this.usageprogressbar = document.getElementById('usagebtn-progress');
				if (this.anitimer)
					this.anitimer.init(this, 100, this.anitimer.TYPE_REPEATING_SLACK);
var hud = document.getElementById('usagebtn-hud');
//hud.style.backgroundImage = "url('chrome://netusagebtn/skin/iconfetch.png')";
hud.setAttribute('style', "background-image: url('chrome://netusagebtn/skin/iconfetch.png')");
var tipinfo = document.getElementById('usagebtn-tip-info');
tipinfo.setAttribute('class', "info");
tipinfo.setAttribute('style', "");
tipinfo.value = "Fetching usage data. Click to abort.";
				} catch(e) { alert(e); }
				break;

			case 'abort':
			case 'error':

if (document.getElementById('usagebtn-container'))
{
				this.animating = false;
var hud = document.getElementById('usagebtn-hud');
hud.setAttribute('style', "background-image: url('chrome://netusagebtn/skin/iconerror.png')");
var tipinfo = document.getElementById('usagebtn-tip-info');
tipinfo.setAttribute('class', "error");
tipinfo.setAttribute('style', "");
	var usagedata = Components.classes["@mozilla.org/netusagecom;1"].getService().QueryInterface(Components.interfaces.nsINetUsageData);
tipinfo.value = usagedata.lasterror;
}
				break;

			default:
				alert(data);

			}
		}
	},

	anitimercallback: function() {
		if (this.anipos >= 9 || this.anipos <= 5) {
			this.anistep = -this.anistep;
		}
		if (this.animating || (!this.animating && this.anipos < 9)) {
			//this.usageprogressbar.style.MozOpacity = '0.'+this.anipos;
			this.usageprogressbar.setAttribute('style', '-moz-opacity: 0.'+this.anipos);
			this.anipos += this.anistep;
		} else {
			// waited for cycle to complete
			this.anitimer.cancel();
			//this.usageprogressbar.style.MozOpacity = '1';
			this.usageprogressbar.setAttribute('style', '-moz-opacity: 1');
			this.anipos = 9;
			this.anistep = 1;
		}

	},

	drawusage: function(usagedata) {

		if (!document.getElementById('usagebtn-container')) return;
		document.getElementById('usagebtn-tip-grid').setAttribute('style', '');

		//var mblbl = document.getElementById('usagebar_myusage');
		var pclbl = document.getElementById('usagebtn-usagepc');

		var barG = document.getElementById('usagebtn-progress-barG');
		//var barW = document.getElementById('usagebtn-progress-barW');
		var barR = document.getElementById('usagebtn-progress-barR');
		var barB = document.getElementById('usagebtn-progress-barB');
		var barY = document.getElementById('usagebtn-progress-barY');
		var usagepbar = document.getElementById('usagebtn-progress');
		var usagemarker = document.getElementById('usagebtn-progress-barM');
		//var baricon = document.getElementById('usagebarIcon');

		var usedpc = parseInt(usagedata.usage/usagedata.quota*100);

		var datepc = ((new Date).getTime() - usagedata.startdate) / (usagedata.enddate - usagedata.startdate)*100;

		if (usedpc <= 100) {
			barG.width = parseInt((usedpc)/100*100);
			barR.setAttribute('width', 0);
			//barW.setAttribute('width', 100-parseInt((usedpc)/100*100) /* parseInt((100-usedpc)/100*100) */ );
			usagemarker.width = parseInt((datepc)/100*100)+3;
		} else {
			//var barmax = Math.ceil(usedpc/200)*200;
			var barmax = usedpc;
			barG.setAttribute('width', parseInt((100)/barmax*100));
			barR.setAttribute('width', 100-parseInt((100)/barmax*100)/*parseInt((usedpc-100)/barmax*100)*/);
			//barW.setAttribute('width', 0);
			usagemarker.width = parseInt((datepc)/barmax*100)+3;
		}

		var usedpopc = parseInt(usagedata.usagepo/usagedata.quotapo*100);
		if (usedpopc <= 100) {
			barB.width = parseInt((usedpopc)/100*100);
			barY.setAttribute('width', 0);
		} else {
			//var barmax = Math.ceil(usedpopc/200)*200;
			var barmax = usedpopc;
			barB.setAttribute('width', parseInt((100)/barmax*100));
			barY.setAttribute('width', 100-parseInt((100)/barmax*100));
		}

		// force repaint
		usagepbar.width = 100;

		//mblbl.setAttribute('value', usagedata.usage + '/' + usagedata.quota + ' MB');
		pclbl.setAttribute('value', usedpc + '%');
		//baricon.setAttribute('src', 'chrome://netusagebar/skin/icon.png');

		//
		// set tooltip
		//

		with (document.getElementById('usagebtn-tip-planname')) {
			{ setAttribute('style', '');
				value = (usagedata.planname) ? usagedata.planname : usagedata.ispname;
			}
		}
		with (document.getElementById('usagebtn-tip-row-headings')) {
			if (usagedata.quotapo) { setAttribute('style', '');
			} else setAttribute('style', 'display: none;');
		}


		document.getElementById('usagebtn-tip-usedquota').value = usagedata.usage+' / '+usagedata.quota;
		with (document.getElementById('usagebtn-tip-usedquotapo')) {
			if (usagedata.quotapo > 0) { setAttribute('style', '');
				value = usagedata.usagepo+' / '+usagedata.quotapo;
			} else setAttribute('style', 'display: none;');
		}

		document.getElementById('usagebtn-tip-row-upload').setAttribute('style', 'display: '+((usagedata.upload > 0 || usagedata.uploadpo > 0) ? '' : 'none'));
		document.getElementById('usagebtn-tip-upload').value = usagedata.upload;
		document.getElementById('usagebtn-tip-row-download').setAttribute('style', 'display: '+((usagedata.download > 0 || usagedata.downloadpo > 0) ? '' : 'none'));
		document.getElementById('usagebtn-tip-download').value = usagedata.download;

		with (document.getElementById('usagebtn-tip-downloadpo')) {
			if (usagedata.quotapo > 0) { setAttribute('style', '');
					value = usagedata.downloadpo;
			} else setAttribute('style', 'display: none;');
		}
		with (document.getElementById('usagebtn-tip-uploadpo')) {
			if (usagedata.uploadpo > 0) { setAttribute('style', '');
				value = usagedata.uploadpo;
			} else setAttribute('style', 'display: none;');
		}

		with (document.getElementById('usagebtn-tip-row-downloadf')) {
			if (usagedata.downloadf > 0) {
				document.getElementById('usagebtn-tip-downloadf').value = usagedata.downloadf;
			} else {
				document.getElementById('usagebtn-tip-downloadf').value = '';
			}
			if (usagedata.downloadfpo > 0) {
				with (document.getElementById('usagebtn-tip-downloadfpo')) {
					setAttribute('style', '');
					value = usagedata.downloadfpo;
				}
			} else {
				with (document.getElementById('usagebtn-tip-downloadfpo')) {
					setAttribute('style', 'display: none;');
					value = '';
				}
			}
			if (usagedata.downloadf+usagedata.downloadfpo <= 0)
				setAttribute('style', 'display: none;');
			else
				setAttribute('style', '');
		}



		// remaining / excess
		var mbremaining = usagedata.quota - usagedata.usage;
		var mbremainingpo = usagedata.quotapo - usagedata.usagepo;

		document.getElementById('usagebtn-tip-row-remain').setAttribute('style', 'display: '+((mbremaining > 0 || mbremainingpo > 0) ? '' : 'none'));
		document.getElementById('usagebtn-tip-row-excess').setAttribute('style', 'display: '+((mbremaining < 0 || mbremainingpo < 0) ? '' : 'none'));

		if (mbremaining > 0) {
			with (document.getElementById('usagebtn-tip-remain')) { value = mbremaining; };
			with (document.getElementById('usagebtn-tip-excess')) { value = ''; };
		} else if (mbremaining < 0) {
			with (document.getElementById('usagebtn-tip-remain')) { value = ''; };
			with (document.getElementById('usagebtn-tip-excess')) { value = Math.abs(mbremaining); };
		} else {
			with (document.getElementById('usagebtn-tip-remain')) { value = '' };
			with (document.getElementById('usagebtn-tip-excess')) { value = ''; };
		}
		if (mbremainingpo > 0) {
			with (document.getElementById('usagebtn-tip-remainpo')) { setAttribute('style', ''); value = mbremainingpo; };
			with (document.getElementById('usagebtn-tip-excesspo')) { setAttribute('style', 'display: none;'); value = ''; };
		} else if (mbremainingpo < 0) {
			with (document.getElementById('usagebtn-tip-remainpo')) { setAttribute('style', 'display: none;'); value = ''; };
			with (document.getElementById('usagebtn-tip-excesspo')) { setAttribute('style', ''); value = Math.abs(mbremainingpo); };
		} else {
			with (document.getElementById('usagebtn-tip-remainpo')) { setAttribute('style', 'display: none;'); value = '' };
			with (document.getElementById('usagebtn-tip-excesspo')) { setAttribute('style', 'display: none;'); value = ''; };
		}

		// update days remaining etc
		var daysremaining = ((usagedata.enddate - (new Date).getTime())/86400000);
		var hrsr = Math.round((usagedata.enddate - (new Date).getTime())/3600000);
		document.getElementById('usagebtn-tip-daysr').value = Math.floor(hrsr / 24)+' d' + ((hrsr % 24 != 0) ? '    '+(hrsr % 24)+' h' : '');

		document.getElementById('usagebtn-tip-daysrav').value = Math.min(Math.abs(mbremaining), Math.max(0, Math.round((usagedata.quota - usagedata.usage)/daysremaining)));
		with (document.getElementById('usagebtn-tip-daysravpo')) {
			if (usagedata.quotapo > 0) { setAttribute('style', '');
				value = Math.min(Math.abs(mbremainingpo), Math.max(0, Math.round((usagedata.quotapo - usagedata.usagepo)/daysremaining)));
			} else setAttribute('style', 'display: none;');
		}

		// update lastfetched info
		netusagetipshowing();

	},

}


addEventListener('load', netusageload, false);

var observerSvc = Components.classes["@mozilla.org/observer-service;1"].getService().QueryInterface(Components.interfaces.nsIObserverService);
observerSvc.addObserver(netusageobj, 'netusage-update-gui', false);


function netusageload() {
/*
	document.getElementById('usagebtn-progress').addEventListener("click", netusageget, true);
	document.getElementById('usagebtn-usagepc').addEventListener("click", netusagevisit, true);
	document.getElementById('usagebtn-tip').addEventListener("popupshowing", netusagetipshowing, true);
*/

	with (netusageobj) {
		anitimer = Components.classes['@mozilla.org/timer;1'].createInstance(Components.interfaces.nsITimer);
	}

	if (!document.getElementById('usagebtn-container')) return;

	var usagedata = Components.classes["@mozilla.org/netusagecom;1"].getService().QueryInterface(Components.interfaces.nsINetUsageData);
	if (usagedata.lastfetched != 0) {
		document.getElementById('usagebtn-tip-info').setAttribute('style', "display: none;");
		netusageobj.drawusage(usagedata);
	} else
		observerSvc.notifyObservers(this, 'netusage-update', 'actfirst');
}


function netusagevisit(event) {

	if (event.button != 0 && event.button != 1) return;

	try {

	portnum = {'http': 80, 'https': 433 };

	var up = nuLoadPass('net:usage:bar');

	if (up[1] == '') { alert('Please configure the extension in the preferences. Then try again.'); return; }

	var usagedata = Components.classes["@mozilla.org/netusagecom;1"].getService().QueryInterface(Components.interfaces.nsINetUsageData);


	if (!usagedata.ispactive) return;

	if (event.button == 1)
		BrowserOpenTab();

	switch (usagedata.ispusagepageauth) {

		case nuISPAuthGet:
		case nuISPAuthBasic:

			if (usagedata.ispusagepageauthrealm) {
				var authman = Components.classes['@mozilla.org/network/http-auth-manager;1'].getService().QueryInterface(Components.interfaces.nsIHttpAuthManager);

				var urlexpr = /^(http|https):\/\/([a-z0-9.\-]+)\/([^\/]*\/)/;
				var urla = urlexpr.exec(usagedata.ispusagepageurl);

				try {
				// backwards compat with pre-1.7
				authman.setAuthIdentity(urla[2] , portnum[urla[1]], usagedata.ispusagepageauthrealm, urla[3], '', up[1], up[2]);
				} catch(e) { }
				try {
				// new auth function
				authman.setAuthIdentity(urla[1], urla[2] , portnum[urla[1]], '', usagedata.ispusagepageauthrealm, urla[3], '', up[1], up[2]);
				} catch(e) { }
			}

			var url = usagedata.ispusagepageurl;
			url = url.replace(/{USERNAME}/, encodeURIComponent(up[1]));
			url = url.replace(/{PASSWORD}/, encodeURIComponent(up[2]));

			window._content.document.location = url;

			break;

		case nuISPAuthPost:
			var userpassstr = usagedata.ispusagepageauthpostdata;
			userpassstr = userpassstr.replace(/{USERNAME}/, encodeURIComponent(up[1]));
			userpassstr = userpassstr.replace(/{PASSWORD}/, encodeURIComponent(up[2]));


			var headerstr = "Content-Type: application/x-www-form-urlencoded\r\nContent-Length: "+userpassstr.length+"\r\n";
			var combinedstr = headerstr+"\r\n"+userpassstr;

			var postdata = Components.classes['@mozilla.org/io/string-input-stream;1'].createInstance(Components.interfaces.nsIStringInputStream);
			postdata.setData(combinedstr, combinedstr.length);
			//var headerdata = Components.classes['@mozilla.org/io/string-input-stream;1'].createInstance(Components.interfaces.nsIStringInputStream);
			//headerdata.setData(headerstr, headerstr.length);

			window.getBrowser().webNavigation.loadURI(usagedata.ispusagepageurl, Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE, null, postdata, null);

			break;


	}

	} catch (e) { alert(e); }

}

function netusageget(event) {
	if (event.button == 0) {
		var up = nuLoadPass('net:usage:bar');
		if (up[1] == '') { alert('Please configure the extension in the preferences. Then try again.'); return; }

		observerSvc.notifyObservers(this, 'netusage-update', 'usage');
	}
}

function netusageopen(win) {
	switch(win) {
	case 'prefs':
		window.open("chrome://netusagebtn/content/pref/usagePrefDlg.xul", "netusage-pref", "chrome");
		break;
	case 'about':
		window.open("chrome://netusagebtn/content/about.xul", "netusage-about", "chrome");
		break;
	}

}

function netusagetipshowing() {

	var usagedata = Components.classes["@mozilla.org/netusagecom;1"].getService().QueryInterface(Components.interfaces.nsINetUsageData);

	if (usagedata.lastfetched == 0) return true;

	// update last fetched
	var nowdiff = (new Date).getTime() - usagedata.lastfetched;

	var h = Math.floor(nowdiff/3600000);
	var m = Math.floor((nowdiff % 3600000) / 60000);
	h = (h == 0) ? '' : h+' hours ';
	m = m+' mins ago';

	document.getElementById('usagebtn-tip-lastfetched').value = h+m;
	return true;
}